#!/bin/sh
# Script para hacer bsquedas de strings en archivos - D. Acosta

#1) Busca en todos los archivos regulares 
#2) usa xargs en vez de -exec para asegurar que la entrada estandar no tendra "overflow"
#3) El comando "file" determina el tipo de archivo 
#4) "grep" busca por archivos de texto si se quieren obviar los binarios...
#5) "cut" corta el nombre del archivo de la salida del grep
#6) Finalmente, "egrep" busca en los archivos (incluidos aquellos comprimidos) por las expresiones regulares definidas en el archivo REGEX_FILE

#Cargue de Variables
REGEX_FILE=regex.txt
NOW=`date +%Y%m%d.%H.%M.%S` 
WHOAMI=`whoami`

if [ $WHOAMI != "root" ]; then
	echo "No eres root. Por permisos, los resultados sern parciales"
fi

echo -n "Directorio de inicio de bsqueda: " 
read DIR 

if [ -d "${DIR}" ]; then

	echo -n "Buscar en archivos binarios y comprimidos (s/n): "
	read B
        echo "Iniciando la bsqueda... esto tardara un poco... "

	if [ $B = "s" ]; then
		#Ejecucin de la bsqueda
		find $DIR -type f -print | xargs file | cut -f1 -d : | xargs egrep -f $REGEX_FILE -Z > resultadoc.$NOW
		# Descomentariar si lo que se quiere es que solo saque los nombres de los archivos en vez de la linea completa 
		# find $DIR -type f -print | xargs file | cut -f1 -d : | xargs egrep -f $REGEX_FILE -Z -l > resultadoc.$NOW
	else 
		#Ejecucin de la bsqueda
                find $DIR -type f -print | xargs file | grep -i text | cut -f1 -d : | xargs egrep -f $REGEX_FILE > resultado.$NOW
                # find $DIR -type f -print | xargs file | grep -i text | cut -f1 -d : | xargs egrep -f $REGEX_FILE -l > resultado.$NOW
	fi
else
	echo "Ingrese un directorio vlido"
	exit 0
fi

exit 0 
